Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.text
Class SimpleDateFormat

    java.lang.Object
      |
      +--java.text.Format
            |
            +--java.text.DateFormat
                  |
                  +--java.text.SimpleDateFormat

All Implemented Interfaces:
  Cloneable, Serializable

public class SimpleDateFormat
extends DateFormat

`SimpleDateFormat` is a concrete class for formatting and parsing dates in a locale-sensitive manner. It allows for formatting (date -> text), parsing (text -> date), and normalization.

`SimpleDateFormat` allows you to start by choosing any user-defined patterns for date-time formatting. However, you are encouraged to create a date-time formatter with either `getTimeInstance`, `getDateInstance`, or `getDateTimeInstance` in `DateFormat`. Each of these class methods can return a date/time formatter initialized with a default format pattern. You may modify the format pattern using the `applyPattern` methods as desired. For more information on using these methods, see `DateFormat`.

Time Format Syntax:

To specify the time format use a time pattern string. In this pattern, all ASCII letters are reserved as pattern letters, which are defined as the following:

>      Symbol   Meaning                 Presentation        Example
>      ------   -------                 ------------        -------
>      G        era designator          (Text)              AD
>      y        year                    (Number)            1996
>      M        month in year           (Text & Number)     July & 07
>      d        day in month            (Number)            10
>      h        hour in am/pm (1~12)    (Number)            12
>      H        hour in day (0~23)      (Number)            0
>      m        minute in hour          (Number)            30
>      s        second in minute        (Number)            55
>      S        millisecond             (Number)            978
>      E        day in week             (Text)              Tuesday
>      D        day in year             (Number)            189
>      F        day of week in month    (Number)            2 (2nd Wed in July)
>      w        week in year            (Number)            27
>      W        week in month           (Number)            2
>      a        am/pm marker            (Text)              PM
>      k        hour in day (1~24)      (Number)            24
>      K        hour in am/pm (0~11)    (Number)            0
>      z        time zone               (Text)              Pacific Standard Time
>      '        escape for text         (Delimiter)
>      ''       single quote            (Literal)           '

The count of pattern letters determine the format.

(Text): 4 or more pattern letters--use full form, < 4--use short or abbreviated form if one exists.

(Number): the minimum number of digits. Shorter numbers are zero-padded to this amount. Year is handled specially; that is, if the count of 'y' is 2, the Year will be truncated to 2 digits.

(Text & Number): 3 or over, use text, otherwise use number.

Any characters in the pattern that are not in the ranges of ['a'..'z'] and ['A'..'Z'] will be treated as quoted text. For instance, characters like ':', '.', ' ', '#' and '@' will appear in the resulting time text even they are not embraced within single quotes.

A pattern containing any invalid pattern letter will result in a thrown exception during formatting or parsing.

Examples Using the US Locale:

>      Format Pattern                         Result
>      --------------                         -------
>      "yyyy.MM.dd G 'at' hh:mm:ss z"    ->>  1996.07.10 AD at 15:08:56 PDT
>      "EEE, MMM d, ''yy"                ->>  Wed, July 10, '96
>      "h:mm a"                          ->>  12:08 PM
>      "hh 'o''clock' a, zzzz"           ->>  12 o'clock PM, Pacific Daylight Time
>      "K:mm a, z"                       ->>  0:00 PM, PST
>      "yyyyy.MMMMM.dd GGG hh:mm aaa"    ->>  1996.July.10 AD 12:08 PM

Code Sample:

>      SimpleTimeZone pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, "PST");
>      pdt.setStartRule(DateFields.APRIL, 1, DateFields.SUNDAY, 2*60*60*1000);
>      pdt.setEndRule(DateFields.OCTOBER, -1, DateFields.SUNDAY, 2*60*60*1000);

>      // Format the current time.
>      SimpleDateFormat formatter
>          = new SimpleDateFormat ("yyyy.MM.dd G 'at' hh:mm:ss a zzz");
>      Date currentTime_1 = new Date();
>      String dateString = formatter.format(currentTime_1);

>      // Parse the previous string back into a Date.
>      ParsePosition pos = new ParsePosition(0);
>      Date currentTime_2 = formatter.parse(dateString, pos);

In the example, the time value `currentTime_2` obtained from parsing will be equal to `currentTime_1`. However, they may not be equal if the am/pm marker 'a' is left out from the format pattern while the "hour in am/pm" pattern symbol is used. This information loss can happen when formatting the time in PM.

When parsing a date string using the abbreviated year pattern ("y" or "yy"), SimpleDateFormat must interpret the abbreviated year relative to some century. It does this by adjusting dates to be within 80 years before and 20 years after the time the SimpleDateFormat instance is created. For example, using a pattern of "MM/dd/yy" and a SimpleDateFormat instance created on Jan 1, 1997, the string "01/11/12" would be interpreted as Jan 11, 2012 while the string "05/04/64" would be interpreted as May 4, 1964. During parsing, only strings consisting of exactly two digits, as defined by `Character.isDigit(char)`, will be parsed into the default century. Any other numeric string, such as a one digit string, a three or more digit string, or a two digit string that isn't all digits (for example, "-1"), is interpreted literally. So "01/02/3" or "01/02/003" are parsed, using the same pattern, as Jan 2, 3 AD. Likewise, "01/02/-3" is parsed as Jan 2, 4 BC.

If the year pattern has more than two 'y' characters, the year is interpreted literally, regardless of the number of digits. So using the pattern "MM/dd/yyyy", "01/11/12" parses to Jan 11, 12 A.D.

For time zones that have no names, use strings GMT+hours:minutes or GMT-hours:minutes.

The calendar defines what is the first day of the week, the first week of the year, whether hours are zero based or not (0 vs 12 or 24), and the time zone. There is one common decimal format to handle all the numbers; the digit count is handled programmatically according to the pattern.

See Also:
  `Calendar`, `GregorianCalendar`, `TimeZone`, `DateFormat`, `DateFormatSymbols`, `DecimalFormat`, Serialized Form

Fields inherited from class java.text.DateFormat
`AM_PM_FIELD, calendar, DATE_FIELD, DAY_OF_WEEK_FIELD, DAY_OF_WEEK_IN_MONTH_FIELD, DAY_OF_YEAR_FIELD, DEFAULT, ERA_FIELD, FULL, HOUR_OF_DAY0_FIELD, HOUR_OF_DAY1_FIELD, HOUR0_FIELD, HOUR1_FIELD, LONG, MEDIUM, MILLISECOND_FIELD, MINUTE_FIELD, MONTH_FIELD, numberFormat, SECOND_FIELD, SHORT, TIMEZONE_FIELD, WEEK_OF_MONTH_FIELD, WEEK_OF_YEAR_FIELD, YEAR_FIELD`

Constructor Summary
`SimpleDateFormat()` Construct a SimpleDateFormat using the default pattern for the default locale.
`SimpleDateFormat(String pattern)` Construct a SimpleDateFormat using the given pattern in the default locale.
`SimpleDateFormat(String pattern, DateFormatSymbols formatData)` Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.
`SimpleDateFormat(String pattern, Locale loc)` Construct a SimpleDateFormat using the given pattern and locale.

Method Summary
`void` | `applyLocalizedPattern(String pattern)` Apply the given localized pattern string to this date format.
`void` | `applyPattern(String pattern)` Apply the given unlocalized pattern string to this date format.
`Object` | `clone()` Overrides Cloneable
`boolean` | `equals(Object obj)` Override equals.
`StringBuffer` | `format(Date date, StringBuffer toAppendTo, FieldPosition pos)` Overrides DateFormat
`Date` | `get2DigitYearStart()` Returns the beginning date of the 100-year period 2-digit years are interpreted as being within.
`DateFormatSymbols` | `getDateFormatSymbols()` Gets the date/time formatting data.
`int` | `hashCode()` Override hashCode.
`Date` | `parse(String text, ParsePosition pos)` Overrides DateFormat
`void` | `set2DigitYearStart(Date startDate)` Sets the 100-year period 2-digit years will be interpreted as being in to begin on the date the user specifies.
`void` | `setDateFormatSymbols(DateFormatSymbols newFormatSymbols)` Allows you to set the date/time formatting data.
`String` | `toLocalizedPattern()` Return a localized pattern string describing this date format.
`String` | `toPattern()` Return a pattern string describing this date format.

Methods inherited from class java.text.DateFormat
`format, format, getAvailableLocales, getCalendar, getDateInstance, getDateInstance, getDateInstance, getDateTimeInstance, getDateTimeInstance, getDateTimeInstance, getInstance, getNumberFormat, getTimeInstance, getTimeInstance, getTimeInstance, getTimeZone, isLenient, parse, parseObject, setCalendar, setLenient, setNumberFormat, setTimeZone`

Methods inherited from class java.text.Format
`format, parseObject`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimpleDateFormat

    public SimpleDateFormat()

  Construct a SimpleDateFormat using the default pattern for the default locale. Note: Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.
  See Also:
    `DateFormat`

### SimpleDateFormat

    public SimpleDateFormat(String pattern)

  Construct a SimpleDateFormat using the given pattern in the default locale. Note: Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

### SimpleDateFormat

    public SimpleDateFormat(String pattern,
                            Locale loc)

  Construct a SimpleDateFormat using the given pattern and locale. Note: Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

### SimpleDateFormat

    public SimpleDateFormat(String pattern,
                            DateFormatSymbols formatData)

  Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.

Method Detail

### set2DigitYearStart

    public void set2DigitYearStart(Date startDate)

  Sets the 100-year period 2-digit years will be interpreted as being in to begin on the date the user specifies.
  Parameters:
    `startDate` - During parsing, two digit years will be placed in the range `startDate` to `startDate + 100 years`.

### get2DigitYearStart

    public Date get2DigitYearStart()

  Returns the beginning date of the 100-year period 2-digit years are interpreted as being within.
  Returns:
    the start of the 100-year period into which two digit years are parsed

### format

    public StringBuffer format(Date date,
                               StringBuffer toAppendTo,
                               FieldPosition pos)

  Overrides DateFormat

  Formats a date or time, which is the standard millis since January 1, 1970, 00:00:00 GMT.

  Example: using the US locale: "yyyy.MM.dd G 'at' HH:mm:ss zzz" ->> 1996.07.10 AD at 15:08:56 PDT

  Overrides:
    `format` in class `DateFormat`
  Parameters:
    `date` - the date-time value to be formatted into a date-time string.
    `toAppendTo` - where the new date-time text is to be appended.
    `pos` - the formatting position. On input: an alignment field, if desired. On output: the offsets of the alignment field.
  Returns:
    the formatted date-time string.
  See Also:
    `DateFormat`

### parse

    public Date parse(String text,
                      ParsePosition pos)

  Overrides DateFormat
  Overrides:
    `parse` in class `DateFormat`
  See Also:
    `DateFormat`

### toPattern

    public String toPattern()

  Return a pattern string describing this date format.

### toLocalizedPattern

    public String toLocalizedPattern()

  Return a localized pattern string describing this date format.

### applyPattern

    public void applyPattern(String pattern)

  Apply the given unlocalized pattern string to this date format.

### applyLocalizedPattern

    public void applyLocalizedPattern(String pattern)

  Apply the given localized pattern string to this date format.

### getDateFormatSymbols

    public DateFormatSymbols getDateFormatSymbols()

  Gets the date/time formatting data.
  Returns:
    a copy of the date-time formatting data associated with this date-time formatter.

### setDateFormatSymbols

    public void setDateFormatSymbols(DateFormatSymbols newFormatSymbols)

  Allows you to set the date/time formatting data.
  Parameters:
    `newFormatData` - the given date-time formatting data.

### clone

    public Object clone()

  Overrides Cloneable
  Overrides:
    `clone` in class `DateFormat`
  Following copied from class: `java.lang.Object`
  Returns:
    a clone of this instance.
  Throws:
    `CloneNotSupportedException` - if the object's class does not support the `Cloneable` interface. Subclasses that override the `clone` method can also throw this exception to indicate that an instance cannot be cloned.
    `OutOfMemoryError` - if there is not enough memory.
  See Also:
    `Cloneable`

### hashCode

    public int hashCode()

  Override hashCode. Generates the hash code for the SimpleDateFormat object
  Overrides:
    `hashCode` in class `DateFormat`
  Following copied from class: `java.lang.Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### equals

    public boolean equals(Object obj)

  Override equals.
  Overrides:
    `equals` in class `DateFormat`
  Following copied from class: `java.lang.Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.